KFilePlugin Class Referenceabstract

`#include <kfilemetainfo.h>`

Inherits QObject.

## Public Member Functions

| KFilePlugin (QObject *parent, const char *name, const QStringList &args)
virtual | ~KFilePlugin ()
virtual bool | readInfo (KFileMetaInfo &info, uint what=KFileMetaInfo::Fastest)=0
virtual bool | writeInfo (const KFileMetaInfo &info) const
virtual QValidator * | createValidator (const QString &mimeType, const QString &group, const QString &key, QObject *parent, const char *name) const

## Protected Member Functions

KFileMimeTypeInfo * | addMimeTypeInfo (const QString &mimeType)
KFileMimeTypeInfo::GroupInfo * | addGroupInfo (KFileMimeTypeInfo *info, const QString &key, const QString &translatedKey) const
void | setAttributes (KFileMimeTypeInfo::GroupInfo *gi, uint attr) const
void | addVariableInfo (KFileMimeTypeInfo::GroupInfo *gi, QVariant::Type type, uint attr) const
KFileMimeTypeInfo::ItemInfo * | addItemInfo (KFileMimeTypeInfo::GroupInfo *gi, const QString &key, const QString &translatedKey, QVariant::Type type)
void | setAttributes (KFileMimeTypeInfo::ItemInfo *item, uint attr)
void | setHint (KFileMimeTypeInfo::ItemInfo *item, uint hint)
void | setUnit (KFileMimeTypeInfo::ItemInfo *item, uint unit)
void | setPrefix (KFileMimeTypeInfo::ItemInfo *item, const QString &prefix)
void | setSuffix (KFileMimeTypeInfo::ItemInfo *item, const QString &suffix)
KFileMetaInfoGroup | appendGroup (KFileMetaInfo &info, const QString &key)
void | appendItem (KFileMetaInfoGroup &group, const QString &key, QVariant value)
virtual void | virtual_hook (int id, void *data)

## Protected Attributes

QStringList | m_preferredKeys
QStringList | m_preferredGroups

## Detailed Description

Base class for a meta information plugin.

Meta information plugins are used to extract useful information from files of a given type. These plugins are used in Konqueror's file properties dialog, for example.

If you want to write your own plugin, you need to derive from this class.

In the constructor of your class, you need to call addMimeTypeInfo() to tell the KFile framework which mimetype(s) your plugin supports. For each mimetype, use the addGroupInfo() and addItemInfo() methods to declare the meta information items the plugin calculates and to group them accordingly. For groups, use setAttributes() to customize your group (see KFileMimeTypeInfo::Attributes). For items, use setAttributes() to define the behaviour of the item; use setHint() to define the meaning of the item; use setUnit() to define the Unit, such as KFileMimeTypeInfo::Seconds or KFileMimeTypeInfo::KiloBytes. In short, the constructor defines the data structure of the meta information supported by your plugin.

Example:

FooPlugin::FooPlugin(QObject *parent, const char *name,
const QStringList &args)
: KFilePlugin(parent, name, args)
{
KFileMimeTypeInfo* info = addMimeTypeInfo( "application/x-foo" );
// our new group
KFileMimeTypeInfo::GroupInfo* group = 0L;
group = addGroupInfo(info, "FooInfo", i18n("Foo Information"));
KFileMimeTypeInfo::ItemInfo* item;
// our new items in the group
item = addItemInfo(group, "Items", i18n("Items"), QVariant::Int);
item = addItemInfo(group, "Size", i18n("Size"), QVariant::Int);
setUnit(item, KFileMimeTypeInfo::KiloBytes);
// strings are possible, too:
//addItemInfo(group, "Document Type", i18n("Document type"), QVariant::String);
}

Some meta information items are likely to be available in several different file formats, such as `"Author"`, `"Title"` (for documents), and `"Length"` (for multimedia files). Be sure to use the naming scheme from existing plugins for your meta information items if possible. If, for example, the meta information of a group of files is shown in a table view, this will allow two files to share the same column (say "Length") even if they are of a different file type.

You must overwrite the readInfo() method. In this method you need to extract the meta information of the given file. You can use a third-party library to achieve this task. This might be the best way for binary files, since a change in the file format is likely to be supported by subsequent releases of that library. Alternatively, for text-based file formats, you can use QTextStream to parse the file. For simple file formats, QRegExp can be of great help, too.

After you extracted the relevant information, use appendGroup() and appendItem() to fill the meta information data structure (as defined in the constructor) with values. Note that you can leave out groups or items which are not appropriate for a particular file.

Example:

bool FooPlugin::readInfo( KFileMetaInfo& info, uint what)
{
int numItems = 0;
int size = 0;
// do your calculations here, e.g. using a third-party
// library or by writing an own parser using e.g. QTextStream
// calculate numItems and size ...
// note: use the same key strings as in the constructor
KFileMetaInfoGroup group = appendGroup(info, "FooInfo");
appendItem(group, "Items", numItems);
appendItem(group, "Size", size);
return true;
}

If you want to define mutable meta information items, you need to overwrite the writeInfo() method. In this method, you can use third-party library (appropriate mostly for binary files, see above) or QTextStream to write the information back to the file. If you use QTextStream, be sure to write all file contents back.

For some items, it might be that not all possible values are allowed. You can overwrite the createValidator() method to define constraints for a meta information item. For example, the `"Year"` field for an MP3 file could reject values outside the range 1500 - 2050 (at least for now). The validator is used to check values before the writeInfo() method is called so that writeInfo() is only provided correct values.

In your plugin, you need to create a factory for the KFilePlugin

Example:

typedef KGenericFactory<FooPlugin> FooFactory;
K_EXPORT_COMPONENT_FACTORY(kfile_foo, FooFactory("kfile_foo"));

To make your plugin available within KDE, you also need to provide a ``.desktop file which describes your plugin. The required fields in the file are:

- `Type:` must be `"Service"`
- `Name:` the name of the plugin
- `ServiceTypes:` must contain `"KFilePlugin"`
- `X-KDE-Library`: the name of the library containing the KFile plugin
- `MimeType:` the mimetype(s) which are supported by the plugin
- `PreferredGroups:` a comma-separated list of the most important groups. This list defines the order in which the meta information groups should be displayed
- `PreferredItems:` a comma-separated list of the most important items. This list defines the order in which the meta information items should be displayed

Example:

[Desktop Entry]
Encoding=UTF-8
Type=Service
Name=Foo Info
ServiceTypes=KFilePlugin
X-KDE-Library=kfile_foo
MimeType=application/x-foo
PreferredGroups=FooInfo
PreferredItems=Items,Size

Definition at line 1394 of file kfilemetainfo.h.

## Constructor & Destructor Documentation

KFilePlugin::KFilePlugin | ( | QObject * | parent,
|  | const char * | name,
|  | const QStringList & | args
| ) |  |

Creates a new KFilePlugin instance.

You need to implement a constructor with the same argument list as this is required by KGenericFactory

Parameters

  parent | the parent of the QObject, can be `0`
  name | the name of the QObject, can be `0`
  args | currently ignored

See also
  addMimeTypeInfo()
  addGroupInfo()
  addItemInfo()
  QObject()

Definition at line 781 of file kfilemetainfo.cpp.

KFilePlugin::~KFilePlugin | ( |  | ) |

virtual

Destructor.

Definition at line 788 of file kfilemetainfo.cpp.

## Member Function Documentation

KFileMimeTypeInfo::GroupInfo * KFilePlugin::addGroupInfo | ( | KFileMimeTypeInfo * | info,
|  | const QString & | key,
|  | const QString & | translatedKey
| ) |  | const

protected

Creates a meta information group for KFileMimeTypeInfo object returned by addMimeTypeInfo().

Parameters

  info | the object returned by addMimeTypeInfo()
  key | a unique string identifiing this group. For simplicity it is recommended to use the same string as for the translatedKey parameter
  translatedKey | the translated version of the key string for displaying in user interfaces. Use i18n() to translate the string

Returns
  a GroupInfo object. Pass this object to addItemInfo to add meta information attributed to this group.

See also
  setAttributes()
  addItemInfo()

Definition at line 802 of file kfilemetainfo.cpp.

KFileMimeTypeInfo::ItemInfo * KFilePlugin::addItemInfo | ( | KFileMimeTypeInfo::GroupInfo * | gi,
|  | const QString & | key,
|  | const QString & | translatedKey,
|  | QVariant::Type | type
| ) |  |

protected

Adds a meta information item to a GroupInfo object as returned by addGroupInfo().

Parameters

  gi | the GroupInfo object to add a new item to
  key | a unique string to identify this item. For simplicity it is recommended to use the same string as for the translatedKey parameter
  translatedKey | the translated version of the key string for displaying in user interfaces. Use i18n() to translate the string
  type | the type of the meta information item, e.g. QVariant::Int or QVariant::String.

Returns
  an ItemInfo object. Pass this object to setAttributes()

Definition at line 819 of file kfilemetainfo.cpp.

KFileMimeTypeInfo * KFilePlugin::addMimeTypeInfo | ( | const QString & | mimeType | ) |

protected

Call this from within your constructor to tell the KFile framework what mimetypes your plugin supports.

Parameters

  mimeType | a string containing the mimetype, e.g. `"text/html"`

Returns
  a KFileMimeTypeInfo object, to be used with addGroupInfo()

Definition at line 793 of file kfilemetainfo.cpp.

KFileMetaInfoGroup KFilePlugin::appendGroup | ( | KFileMetaInfo & | info,
|  | const QString & | key
| ) |  |

protected

Call this method from within readInfo() to indicate that you wish to fill meta information items of the group identified by `key` with values.

Parameters

  info | the KFileMetaInfo object. Use the parameter of the readInfo() method
  key | the key string to identify the group. Use the string that you defined in your class' constructor

Returns
  a KFileMetaInfoGroup object, to be used in appendItem()

Definition at line 894 of file kfilemetainfo.cpp.

void KFilePlugin::appendItem | ( | KFileMetaInfoGroup & | group,
|  | const QString & | key,
|  | QVariant | value
| ) |  |

protected

Call this method from within readInfo() to fill the meta information item identified by `key` with a `value`.

Parameters

  group | the KFileMetaInfoGroup object, as returned by appendGroup()
  key | the key string to identify the item.
  value | the value of the meta information item

Definition at line 899 of file kfilemetainfo.cpp.

virtual QValidator* KFilePlugin::createValidator | ( | const QString & | mimeType,
|  | const QString & | group,
|  | const QString & | key,
|  | QObject * | parent,
|  | const char * | name
| ) |  | const

inline virtual

This method should create an appropriate validator for the specified item if it's editable or return a null pointer if not.

If you don't have any editable items, you don't need to implement this method.

If you you don't need any validation, e.g. you accept any input, you can simply return `0L`, or not reimplement this method at all.

Parameters

  mimeType | the mime type
  group | the group name of the validator item
  key | the key name of the validator item
  parent | the QObject parent, can be `0`
  name | the name of the QObject, can be `0`

Definition at line 1462 of file kfilemetainfo.h.

virtual bool KFilePlugin::readInfo | ( | KFileMetaInfo & | info,
|  | uint | what = `KFileMetaInfo::Fastest`
| ) |  |

pure virtual

Read the info from the file in this method and insert it into the provided KFileMetaInfo object.

You can get the path to the file with KFileMetaInfo::path(). Use appendGroup() and appendItem() to fill `info` with the extracted values

Parameters

  info | the information will be written here
  what | defines what to read, see KFileMetaInfo::What

Returns
  `true` if successful, `false` if it failed

See also
  writeInfo()

void KFilePlugin::setAttributes | ( | KFileMimeTypeInfo::GroupInfo * | gi,
|  | uint | attr
| ) |  | const

protected

Sets attributes of the GroupInfo object returned by addGroupInfo().

Parameters

  gi | the object returned by addGroupInfo()
  attr | the attributes for this group; these are values of type KFileMimeTypeInfo::Attributes, or'ed together

Definition at line 808 of file kfilemetainfo.cpp.

void KFilePlugin::setAttributes | ( | KFileMimeTypeInfo::ItemInfo * | item,
|  | uint | attr
| ) |  |

protected

Sets some attributes for a meta information item.

The attributes describe if the item is mutable, how it should be computed for a list of files, and how it should be displayed

Parameters

  item | the ItemInfo object as returned by addItemInfo()
  attr | the attributes for this item; these are values of type KFileMimeTypeInfo::Attributes, or'ed together

Definition at line 827 of file kfilemetainfo.cpp.

void KFilePlugin::setHint | ( | KFileMimeTypeInfo::ItemInfo * | item,
|  | uint | hint
| ) |  |

protected

Defines the meaning of the meta information item.

Some applications make use of this information, so be sure to check KFileMimeTypeInfo::Hint to see if an item's meaning is in the list.

Parameters

  item | the ItemInfo object as returned by addItemInfo()
  hint | the item's meaning. See KFileMimeTypeInfo::Hint for a list of available meanings

Definition at line 832 of file kfilemetainfo.cpp.

void KFilePlugin::setPrefix | ( | KFileMimeTypeInfo::ItemInfo * | item,
|  | const QString & | prefix
| ) |  |

protected

Sets a prefix string which is displayed before the item's value.

Use this string if no predefined unit fits the item's unit. Be sure to translate the string with i18n()

Parameters

  item | the ItemInfo object as returned by addItemInfo()
  prefix | the prefix string to display

Definition at line 884 of file kfilemetainfo.cpp.

void KFilePlugin::setSuffix | ( | KFileMimeTypeInfo::ItemInfo * | item,
|  | const QString & | suffix
| ) |  |

protected

Sets a suffix string which is displayed before the item's value.

Use this string if no predefined unit fits the item's unit. Be sure to translate the string with i18n()

Parameters

  item | the ItemInfo object as returned by addItemInfo()
  suffix | the suffix string to display

Definition at line 889 of file kfilemetainfo.cpp.

void KFilePlugin::setUnit | ( | KFileMimeTypeInfo::ItemInfo * | item,
|  | uint | unit
| ) |  |

protected

Sets the unit used in the meta information item.

This unit is used to format the value and to make large values human-readable. For example, if the item's unit is KFileMimeTypeInfo::Seconds and the value is 276, it will be displayed as 4:36.

Parameters

  item | the ItemInfo object as returned by addItemInfo()
  unit | the item's unit. See KFileMimeTypeInfo::Unit for a list of available units

Definition at line 837 of file kfilemetainfo.cpp.

void KFilePlugin::virtual_hook | ( | int | id,
|  | void * | data
| ) |  |

protected virtual

Helper method to allow binary compatible extensions when needing "new virtual methods".

Parameters

  id | the identifier of the new "virtual" method
  data | any parameter data the new "virtual" method needs

Definition at line 798 of file kfilemetainfo.cpp.

virtual bool KFilePlugin::writeInfo | ( | const KFileMetaInfo & | info | ) | const

inline virtual

Similar to the readInfo() but for writing the info back to the file.

If you don't have any writable keys, don't implement this method

Parameters

  info | the information that will be written

Returns
  `true` if successful, `false` if it failed

Definition at line 1442 of file kfilemetainfo.h.

The documentation for this class was generated from the following files:

- kfilemetainfo.h
- kfilemetainfo.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys